#include </usr/include/libusb-1.0/libusb.h>
#include <stdlib.h>
#include <stdio.h>
//struct configuration
//{
//	libusb_device_handle *handle;
//	int bNumEndpoints;
struct configuration {
	libusb_device_handle *handl;
	uint8_t interface;
	uint8_t endpoint;
};
struct configuration configManette[20];

void communication () {
	int endpoint_out=Manette[nb_manette].endpoint;   /* ID of endpoint (bit 8 is 0) */
	char data[MAX_DATA];    /* data to send or to receive */
	int size=64;           /* size to send or maximum size to receive */
	int timeout=10;        /* timeout in ms */
	int bytes_out;
	int status=libusb_interrupt_transfer(handle,endpoint_out,data,size,&bytes_out,timeout);
	if(status!=0){ perror("libusb_interrupt_transfer"); exit(-1); }
	}


int main(){
	int nb_manette=0;
	libusb_context *context;
	int status=libusb_init(&context);
	if(status!=0) {perror("libusb_init"); exit(-1);}

	libusb_device **list;
	ssize_t count=libusb_get_device_list(context,&list);
	if(count<0) {perror("libusb_get_device_list"); exit(-1);}
	ssize_t i=0;
	for(i=0;i<count;i++){
 		 libusb_device *device=list[i];
  		struct libusb_device_descriptor desc;
  		int status=libusb_get_device_descriptor(device,&desc);
  		if(status!=0) continue;
  		uint8_t bus=libusb_get_bus_number(device);
  		uint8_t address=libusb_get_device_address(device);
  		printf("Device Found @ (Bus:Address) %d:%d\n",bus,address);
  		printf("Vendor ID 0x0%x\n",desc.idVendor);
  		printf("Product ID 0x0%x\n",desc.idProduct);
 		 if (desc.idVendor == 0x03eb && desc.idProduct == 0x02ff4){
			nb_manette++;
			//alors on récupère sa  configuration
			libusb_device_handle *handle; // on récupère le handle 
			int status=libusb_open(device,&handle);
			if(status!=0){ perror("libusb_open"); exit(-1); }
			struct libusb_config_descriptor* config;
			int nb_interface= config->bNumInterfaces;
			printf("%d\n",nb_interface);
			//faire une boucle for
	
			for(int i=0;i<nb_interface;i++){
				if(config->interface[i].altsetting[0].bInterfaceClass == LIBUSB_CLASS_VENDOR_SPEC)
				{
					configManette[nb_manette].handl=handle;
					configManette[nb_manette].interface=config->interface[i].altsetting[0].bInterfaceNumber;
					configManette[nb_manette].endpoint=config->interface[i].altsetting[0].endpoint[0].bEndpointAddress;i
					printf("Num interface = %d and EndpointAddress = %d\n", bInterfaceNumber, bEndpointAddress);

	
			}

			libusb_close(handle);

 		 }
		}
		else printf("pas trouve\n");
		}
		libusb_free_device_list(list,1);


	      	libusb_exit(context);

}
